#include <stdio.h>
#include <string.h>

int provera(char s1[], char s2[], char s3[]){
    int r=0,i,l;
    int l1=strlen(s1),l2=strlen(s2),l3=strlen(s3);
    l=(l1<l2)?l1:l2;
    for(i=0;i<l;i++){
        if(s1[i]==s2[l-i])
            r++;
    }
    l=(l2<l3)?l2:l3;
    for(i=0;i<l;i++){
        if(s2[i]==s3[l-i])
            r++;
    }
    return r;
}

int main()
{
    int n=0,i,j,k;
    char s[256];
    gets(s);
    int l = strlen(s);
    for(i=l/2;i>=2;i--){
        for(j=l/2;j>=2;j--){
            for(k=l/2;k>=2;k--){
                if(i+j+k==l){
                    char p[i],d[j],t[k];
                    strcpy(p,s);
                    p[i]='\0';
                    strcpy(d,s+i);
                    d[j]='\0';
                    strcpy(t,s+i+j);
                    t[k]='\0';
                    int r = provera(p,d,t);
                    n=(r>n)?r:n;
                }
            }
        }
    }
    printf("%d",n);
    return 0;
}